Upstream-Status: Pending
From 3ef1de52006f90bbdf38712fc65784b91c2819f2 Mon Sep 17 00:00:00 2001
From: Rajesh Gugulothu <gugulothu.rajesh@xilinx.com>
Date: Thu, 23 Jun 2022 12:42:58 +0530
Subject: [PATCH 234/295] v4l: xilinx: dprx: Fix compilation error
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

This patch fixes the below compilation error with DisplayPort Rx driver
when debug is enabled.

In file included from <command-line>:
drivers/media/platform/xilinx/xilinx-dprxss.c: In function
‘xdprxss_clrset.constprop’:
././include/linux/compiler_types.h:322:45: error: call to
‘__compiletime_assert_503’ declared with attribute error: FIELD_PREP:
mask is not constant
  322 |         _compiletime_assert(condition, msg, __compiletime_assert_,
__COUNTER__)
      |                                             ^
././include/linux/compiler_types.h:303:25: note: in definition of macro
‘__compiletime_assert’
  303 |                         prefix ## suffix();                     \
      |                         ^~~~~~
././include/linux/compiler_types.h:322:9: note: in expansion of macro
‘_compiletime_assert’
  322 |         _compiletime_assert(condition, msg, __compiletime_assert_,
__COUNTER__)
      |         ^~~~~~~~~~~~~~~~~~~
./include/linux/build_bug.h:39:37: note: in expansion of macro
‘compiletime_assert’
   39 | #define BUILD_BUG_ON_MSG(cond, msg)
compiletime_assert(!(cond), msg)
      |                                     ^~~~~~~~~~~~~~~~~~
./include/linux/bitfield.h:46:17: note: in expansion of macro
‘BUILD_BUG_ON_MSG’
   46 |                 BUILD_BUG_ON_MSG(!__builtin_constant_p(_mask),  \
      |                 ^~~~~~~~~~~~~~~~
./include/linux/bitfield.h:94:17: note: in expansion of macro
‘__BF_FIELD_CHECK’
   94 |                 __BF_FIELD_CHECK(_mask, 0ULL, _val,
"FIELD_PREP: "); \
      |                 ^~~~~~~~~~~~~~~~
drivers/media/platform/xilinx/xilinx-dprxss.c:597:19: note: in expansion
of macro ‘FIELD_PREP’
  597 |         regval |= FIELD_PREP(clr_mask, set_data);
      |                   ^~~~~~~~~~

Signed-off-by: Rajesh Gugulothu <gugulothu.rajesh@xilinx.com>
State: pending
---
 drivers/media/platform/xilinx/xilinx-dprxss.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/drivers/media/platform/xilinx/xilinx-dprxss.c b/drivers/media/platform/xilinx/xilinx-dprxss.c
index f847a92f8ae9..ae67f18e007b 100644
--- a/drivers/media/platform/xilinx/xilinx-dprxss.c
+++ b/drivers/media/platform/xilinx/xilinx-dprxss.c
@@ -622,7 +622,7 @@ static void xdprxss_clrset(struct xdprxss_state *dp, u32 addr,
 
 	regval = xdprxss_read(dp, addr);
 	regval &= ~clr_mask;
-	regval |= FIELD_PREP(clr_mask, set_data);
+	regval |= set_data << __bf_shf(clr_mask);
 	xdprxss_write(dp, addr, regval);
 }
 
-- 
2.34.1

